extends KinematicBody2D

const FLOOR_NORMAL := Vector2.UP

export var speed := Vector2(650.0, 1600.0)
export var gravity := 4500.0

var _velocity := Vector2.ZERO


func _physics_process(delta: float) -> void:
	var direction := get_input_direction()

	_velocity.x = speed.x * direction.x
	_velocity.y += gravity * delta

	if direction.y != 0.0:
		_velocity.y = speed.y * direction.y

	var is_jump_interrupted := Input.is_action_just_released("ui_up") and _velocity.y < 0.0
	if is_jump_interrupted:
		_velocity.y = 0.0

	_velocity = move_and_slide(_velocity, FLOOR_NORMAL)


func get_input_direction() -> Vector2:
	return Vector2(
		Input.get_action_strength("ui_right") - Input.get_action_strength("ui_left"),
		-int(Input.is_action_just_pressed("ui_up")) if is_on_floor() else 0.0
	)
